#!/usr/local/bin/ruby
# $Id: ioccom.rb,v 1.2 2001/08/27 15:40:02 bfeldman Exp $
module Ioccom
end
class << Ioccom
	IOCPARM_MASK =		0x1fff
	def IOCPARM_LEN(x)	(x >> 16) & IOCPARM_MASK end
	def IOCBASECMD(x)	x & ~(IOCPARM_MASK << 16) end
	def IOCGROUP(x)		(x >> 8) & 0xff end
	IOCPARM_MAX =		`/sbin/sysctl -n hw.pagesize`.to_i
	IOC_VOID =			0x20000000
	IOC_OUT =			0x40000000
	IOC_IN =			0x80000000
	IOC_INOUT =			(IOC_IN | IOC_OUT)
	IOC_DIRMASK =		(IOC_VOID | IOC_OUT | IOC_IN)
	def _IOC(inout, group, num, len)
		inout | ((len & IOCPARM_MASK) << 16) | (group[0] << 8) | num
	end
	def _IO(g, n)		_IOC(IOC_VOID,	g, n, 0) end
	def _IOR(g, n, t)	_IOC(IOC_OUT,	g, n, t.size) end
	def _IOW(g, n, t)	_IOC(IOC_IN,	g, n, t.size) end
	def _IOWR(g, n, t)	_IOC(IOC_INOUT,	g, n, t.size) end
end
